import { EditorView } from "../../view";
import { EditorState, Extension } from "../../state";
import { Tooltip } from "../../tooltip";
export interface AutocompleteData {
    completeAt: (state: EditorState, pos: number) => CompletionResult | Promise<CompletionResult>;
}
export interface CompletionResult {
    items: readonly Completion[];
}
export interface Completion {
    label: string;
    start: number;
    end: number;
    apply?: string | ((view: EditorView) => void);
}
export declare function completeFromSyntax(state: EditorState, pos: number): CompletionResult | Promise<CompletionResult>;
export declare function sortAndFilterCompletion(substr: string, items: ReadonlyArray<Completion>): Completion[];
export declare function autocomplete(config?: Partial<AutocompleteData>): Extension;
export declare function moveCompletion(dir: string): (view: EditorView) => boolean;
export declare function acceptCompletion(view: EditorView): boolean;
export declare function startCompletion(view: EditorView): boolean;
export declare function getActiveCompletion(view: EditorView): ActiveCompletion | "pending" | null;
export declare function applyCompletion(view: EditorView, option: Completion): void;
export declare function closeCompletion(view: EditorView): boolean;
declare class ActiveCompletion {
    readonly options: readonly Completion[];
    readonly selected: number;
    readonly tooltip: (view: EditorView) => Tooltip;
    constructor(options: readonly Completion[], selected: number, tooltip: (view: EditorView) => Tooltip);
}
export {};
//# sourceMappingURL=index.d.ts.map