import { EditorView, ViewUpdate, BlockInfo } from "../../view";
import { Range, RangeValue, RangeSet } from "../../rangeset";
import { ChangeSet, Annotation, Extension } from "../../state";
export declare abstract class GutterMarker extends RangeValue {
    compare(other: GutterMarker): boolean;
    abstract eq(other: GutterMarker): boolean;
    map(mapping: ChangeSet, pos: number): Range<GutterMarker> | null;
    toDOM(view: EditorView): Node | null;
    at(pos: number): Range<this>;
    elementClass: string;
}
declare type Handlers = {
    [event: string]: (view: EditorView, line: BlockInfo, event: any) => boolean;
};
export interface GutterConfig {
    style?: string;
    renderEmptyElements?: boolean;
    initialMarkers?: (view: EditorView) => RangeSet<GutterMarker>;
    updateMarkers?: (markers: RangeSet<GutterMarker>, update: ViewUpdate) => RangeSet<GutterMarker>;
    lineMarker?: (view: EditorView, line: BlockInfo, markers: readonly GutterMarker[]) => GutterMarker | null;
    initialSpacer?: null | ((view: EditorView) => GutterMarker);
    updateSpacer?: null | ((spacer: GutterMarker, update: ViewUpdate) => GutterMarker);
    domEventHandlers?: Handlers;
}
export declare function gutter(config: GutterConfig): Extension[];
export declare function gutters(config?: {
    fixed?: boolean;
}): Extension[];
export interface LineNumberConfig {
    formatNumber?: (lineNo: number) => string;
    domEventHandlers?: Handlers;
}
export declare const lineNumberMarkers: (value: LineNumberMarkerUpdate) => Annotation<LineNumberMarkerUpdate>;
export declare type LineNumberMarkerUpdate = {
    add?: Range<GutterMarker>[];
    filter?: (from: number, to: number, marker: GutterMarker) => boolean;
};
export declare function lineNumbers(config?: LineNumberConfig): Extension;
export {};
//# sourceMappingURL=index.d.ts.map