import { EditorView, Command } from "../../view";
import { Annotation, Extension } from "../../state";
export interface Diagnostic {
    from: number;
    to: number;
    severity: "info" | "warning" | "error";
    source?: string;
    message: string;
    actions?: readonly Action[];
}
export interface Action {
    name: string;
    apply: (view: EditorView, from: number, to: number) => void;
}
export declare const setDiagnostics: (value: readonly Diagnostic[]) => Annotation<readonly Diagnostic[]>;
export declare function linting(): Extension;
export declare const openLintPanel: Command;
export declare const closeLintPanel: Command;
export declare function linter(source: (view: EditorView) => readonly Diagnostic[]): Extension;
//# sourceMappingURL=lint.d.ts.map