import { Text } from "../../text";
import { Annotation } from "./extension";
import { EditorState } from "./state";
import { EditorSelection, SelectionRange } from "./selection";
import { Change, ChangeSet } from "./change";
import { Extension, Configuration } from "./facet";
export declare class Transaction {
    readonly startState: EditorState;
    changes: ChangeSet;
    docs: Text[];
    selection: EditorSelection;
    private _annotations;
    private flags;
    reconfigureConfig: Configuration | null;
    private state;
    constructor(startState: EditorState, time?: number);
    get doc(): Text;
    annotate(...annotations: Annotation<any>[]): Transaction;
    annotation<T>(type: (value: T) => Annotation<T>): T | undefined;
    annotations<T>(type: (value: T) => Annotation<T>): readonly T[];
    change(change: Change, mirror?: number): Transaction;
    get docChanged(): boolean;
    replace(from: number, to: number, text: string | readonly string[]): Transaction;
    replaceSelection(text: string | readonly string[]): Transaction;
    forEachRange(f: (range: SelectionRange, tr: Transaction) => SelectionRange): Transaction;
    setSelection(selection: EditorSelection): Transaction;
    get selectionSet(): boolean;
    scrollIntoView(): Transaction;
    get scrolledIntoView(): boolean;
    reconfigure(extension: Extension): this;
    get reconfigured(): boolean;
    private ensureOpen;
    apply(): EditorState;
    invertedChanges(): ChangeSet<Change>;
    static time: (value: number) => Annotation<number>;
    static preserveGoalColumn: (value: boolean) => Annotation<boolean>;
    static userEvent: (value: string) => Annotation<string>;
    static addToHistory: (value: boolean) => Annotation<boolean>;
}
//# sourceMappingURL=transaction.d.ts.map