import { EditorState, ChangedRange, Mapping } from "../../state";
import { DecorationSet } from "./decoration";
import { HeightMap, HeightOracle, BlockInfo } from "./heightmap";
import { ViewUpdate } from "./extension";
import { DocView } from "./docview";
export declare class ViewState {
    state: EditorState;
    viewportTop: number;
    viewportBottom: number;
    paddingTop: number;
    paddingBottom: number;
    heightOracle: HeightOracle;
    heightMap: HeightMap;
    scrollTo: number;
    printing: boolean;
    viewport: Viewport;
    constructor(state: EditorState);
    update(update: ViewUpdate, scrollTo?: number): readonly ChangedRange[];
    measure(docView: DocView, repeated: boolean): number;
    getViewport(bias: number, scrollTo: number): Viewport;
    mapViewport(viewport: Viewport, changes: Mapping): Viewport | null;
    viewportIsCovering({ from, to }: Viewport, bias?: number): boolean;
    lineAt(pos: number, editorTop: number): BlockInfo;
    lineAtHeight(height: number, editorTop: number): BlockInfo;
    blockAtHeight(height: number, editorTop: number): BlockInfo;
    forEachLine(from: number, to: number, f: (line: BlockInfo) => void, editorTop: number): void;
}
export declare class Viewport {
    readonly from: number;
    readonly to: number;
    constructor(from: number, to: number);
    eq(b: Viewport): boolean;
}
export declare function decoChanges(diff: readonly ChangedRange[], decorations: readonly DecorationSet[], oldDecorations: readonly DecorationSet[], oldLength: number): {
    content: number[];
    height: number[];
};
export declare function extendWithRanges(diff: readonly ChangedRange[], ranges: number[]): readonly ChangedRange[];
//# sourceMappingURL=viewstate.d.ts.map